// CONTAINERS:
//
// Sequence containers (ordinati per inserimento)
//       vector, array, list, string, 
//       deque, forward_list, valarray
//
// Associative containers (ordinamento parziale)
//       set, multiset, map, multimap
//
// Unordered containers ("hashed")
//       unordered_set, ecc...
//
// (Container adapters
//       priority_queue, stack)


#include <iostream>
#include <vector>
#include <deque>  // double-ended
#include <list>
using namespace std;

int main() {
  vector<int> v;
  // 2048 --> giocateci!
  v.push_back(4); v.push_back(8); v.push_back(16);
  v[2] = 64;  // lvalue
  cout << v[0] << " " << v[1] << " " << v[2] << endl;

  // nota: non c'e' "push_front()"
  // ---> c'e' in deque

  list<int> l;  // (doubly-linked list)
  l.push_back(4); l.push_back(7);
  l.push_front(9);
  cout << l.front() << " " << l.back() << endl;
  
}
